<?php
/**
 * @package Simplicity Add Fields Search Engine
 * 
 * Copyright (C) 2018 CattleMute.
 *
 * Controller
 *
 */

class Safse {

	function __construct() {

		global $SafseAdmin, $SafseFrontal;

		$SafseAdmin = new SafseAdmin();
		$SafseFrontal = new SafseFrontal();

		// Move out
		// if ( ! file_exists( get_stylesheet_directory() . '/searchform-safse.php' ) ) {
		// 	copy( dirname( __FILE__ ) . '/../views/searchform-safse.php', get_stylesheet_directory() . '/searchform-safse.php' );
		// }

		add_action( 'admin_menu', array( $this, 'menu' ) );
		add_action( 'admin_init', array( $this, 'enqueue_script' ) );

	}

	public function menu() {

		add_menu_page( __( 'Search in site', 'safse' ), __( 'Search in site', 'safse' ), 'manage_options', 'safse', array( $this, 'dashboard' ), 'dashicons-search', 80 );
		add_submenu_page( 'safse', __( 'Search in site settings', 'safse' ), __( 'Search in site settings', 'safse' ), 'manage_options', 'safse_settings', array( $this, 'setting' ) );

	}

	public function enqueue_script() {

		if( is_admin() && isset( $_GET['page'] ) && false !== strpos( esc_html( $_GET['page'] ) ,'safse' ) )
			wp_enqueue_style( 'style-safse', plugins_url() . '/simplicity-add-fields-search-engine/css/style.css' );

	}

	public function dashboard() {

		require( dirname(__FILE__) . '/../views/template-dashboard.php' );

	}

	public function setting() {

		global $SafseAdmin;

		$_option      = $SafseAdmin->option();
		$_option_name = $SafseAdmin->get_option_name();

		$_export_template_array       = array( 'no' => 'No', 'yes' => 'Yes' );
		$_loop_mode_array             = array( 'rewrite' => 'Rewrite Main Loop', 'query' => 'WP_Query (Conventional Mode)' );
		$_post_type_array             = $SafseAdmin->get_post_type();
		$_keyword_switch_array        = array( 'and' => 'AND', 'or' => 'OR' );
		$_keyword_switch_user_array   = array( 'no' => 'No', 'yes' => 'Yes' );
		$_multibyte_space_array       = array( 'collapse' => 'Collapse', 'separate' => 'Separate' );
		$_show_checkbox_array         = array( 'no' => 'No', 'yes' => 'Yes' );
		$_hide_checkbox_heading_array = array( 'no' => 'No', 'yes' => 'Yes' );
		$_pass_sort_hidden_array      = array( 'no' => 'No', 'yes' => 'Yes' );
		$_default_sort_char_array     = array( 'no' => 'No', 'yes' => 'Yes' );
		$_set_sort_asc_or_desc_array  = array( 'both' => 'Both', 'desc' => 'Only Descending', 'asc' => 'Only Ascending' );
		$_search_form_show_sort_array = array( 'no' => 'No', 'yes' => 'Yes' );
		$_between_taxonomy_array      = array( 'or' => 'OR', 'and' => 'AND' );
		$_between_term_array          = array( 'in' => 'IN', 'notin' => 'NOT IN', 'and' => 'AND' );
		$_between_term_include_array  = $SafseAdmin->get_between_term();
		$_sort_key_array              = $SafseAdmin->get_fields_sort();
		$_sort_key_names_array        = $SafseAdmin->get_fields_sort();
		$_exclude_title_post_types_array = $SafseAdmin->get_post_type();
		$_exclude_content_post_types_array = $SafseAdmin->get_post_type();

		if ( isset( $_POST[$_option_name] ) ){

			$_data = array();

			foreach ( $_POST[$_option_name] as $_key => $_val ){
				$_data[$_key] = ! is_array( $_val ) ? stripslashes( $_val ) : $_val;
			}

			update_option( $_option_name, $_data );

			$_option = $SafseAdmin->option();

		}

		if ( ! empty( $_POST ) ) {
			echo '<div id="setting-error-settings_updated" class="updated settings-error notice is-dismissible" style="margin-left:0;"><p><strong>' . __( 'Saved.', 'safse' ) . '</strong></p></div>';

			if ( isset( $_POST[$_option_name]['export_template'] ) && 'yes' === $_POST[$_option_name]['export_template'] && ! file_exists( get_stylesheet_directory() . '/searchform-safse.php' ) ) {
				copy( dirname( __FILE__ ) . '/../views/searchform-safse.php', get_stylesheet_directory() . '/searchform-safse.php' );

				echo '<div id="setting-error-settings_updated" class="updated settings-error notice is-dismissible" style="margin-left:0;"><p><strong>' . __( 'Exported the plugins searchform template to theme.', 'safse' ) . '</strong></p></div>';
			}
		}

		require( dirname(__FILE__) . '/../views/template-setting.php' );

	}

}

class SafseAdmin {

	const SAFSE_ADMIN_OPTION = 'safse_setting';

	public function get_option_name(){

		return self::SAFSE_ADMIN_OPTION;

	}

	public function option() {

		$_option = get_option(self::SAFSE_ADMIN_OPTION);

		$_option['export_template']       = false !== $_option && isset( $_option['export_template'] ) ? $_option['export_template'] : 'no';
		$_option['loop_mode']             = false !== $_option && isset( $_option['loop_mode'] ) ? $_option['loop_mode'] : 'query';
		$_option['post_type']             = false !== $_option && isset( $_option['post_type'] ) ? $_option['post_type'] : false;
		$_option['fields_prefix']         = false !== $_option && isset( $_option['fields_prefix'] ) ? $_option['fields_prefix'] : '';
		$_option['keyword_switch']        = false !== $_option && isset( $_option['keyword_switch'] ) ? $_option['keyword_switch'] : 'and';
		$_option['keyword_switch_user']   = false !== $_option && isset( $_option['keyword_switch_user'] ) ? $_option['keyword_switch_user'] : 'no';
		$_option['multibyte_space']       = false !== $_option && isset( $_option['multibyte_space'] ) ? $_option['multibyte_space'] : 'collapse';
		$_option['between_taxonomy']      = false !== $_option && isset( $_option['between_taxonomy'] ) ? $_option['between_taxonomy'] : 'or';
		$_option['between_term']          = false !== $_option && isset( $_option['between_term'] ) ? $_option['between_term'] : false;
		$_option['show_checkbox']         = false !== $_option && isset( $_option['show_checkbox'] ) ? $_option['show_checkbox'] : 'no';
		$_option['hide_checkbox_heading'] = false !== $_option && isset( $_option['hide_checkbox_heading'] ) ? $_option['hide_checkbox_heading'] : 'no';
		$_option['pass_sort_hidden']      = false !== $_option && isset( $_option['pass_sort_hidden'] ) ? $_option['pass_sort_hidden'] : 'no';
		$_option['default_sort_char']     = false !== $_option && isset( $_option['default_sort_char'] ) ? $_option['default_sort_char'] : 'no';
		$_option['set_sort_asc_or_desc']  = false !== $_option && isset( $_option['set_sort_asc_or_desc'] ) ? $_option['set_sort_asc_or_desc'] : 'both';
		$_option['search_form_show_sort'] = false !== $_option && isset( $_option['search_form_show_sort'] ) ? $_option['search_form_show_sort'] : 'no';
		$_option['placeholder_string']    = false !== $_option && isset( $_option['placeholder_string'] ) ? $_option['placeholder_string'] : '';
		$_option['button_string']         = false !== $_option && isset( $_option['button_string'] ) ? $_option['button_string'] : '';
		$_option['sort_key']              = false !== $_option && isset( $_option['sort_key'] ) ? $_option['sort_key'] : false;
		$_option['sort_key_names']        = false !== $_option && isset( $_option['sort_key_names'] ) ? $_option['sort_key_names'] : false;
		$_option['exclude_title_post_types']   = false !== $_option && isset( $_option['exclude_title_post_types'] ) ? $_option['exclude_title_post_types'] : false;
		$_option['exclude_content_post_types'] = false !== $_option && isset( $_option['exclude_content_post_types'] ) ? $_option['exclude_content_post_types'] : false;

		return $_option;

	}
	
	public function get_post_type() {

		$_post_type = get_post_types( array( 'public' => true ) );

		unset( $_post_type['attachment'] );

		$_post_type = array_values( $_post_type );

		return $_post_type;

	}

	public function get_taxonomy() {

		$_taxonomy = get_taxonomies();

		unset( $_taxonomy['nav_menu'], $_taxonomy['link_category'], $_taxonomy['post_format'] );

		$_taxonomy = array_values( $_taxonomy );

		return $_taxonomy;

	}

	public function get_between_term() {

		$_taxonomy = array();

		$_array = $this->get_taxonomy();

		foreach ( $_array as $_key => $_val ) {
			$_taxonomy[$_val] = 'IN';
		}

		$_taxonomy = array_merge( array( 'category' => 'IN', 'post_tag' => 'IN' ), $_taxonomy );

		return $_taxonomy;

	}

	public function get_fields_grep(){

		global $wpdb;

		$_query = "
		SELECT
			DISTINCT $wpdb->postmeta.meta_key
		FROM
			$wpdb->posts
		LEFT OUTER JOIN
			$wpdb->postmeta
		ON
			$wpdb->posts.ID = $wpdb->postmeta.post_id
		WHERE
			    $wpdb->postmeta.meta_key NOT LIKE '\_%'
			AND $wpdb->posts.post_status = 'publish'
		";

		$_query = $wpdb->get_col( $_query );
		
		return $_query;

	}

	public function get_fields_sort(){

		$get_fields_sort = array_merge( array( 'post_date', 'post_title' ), $this->get_fields_grep() );

		return $get_fields_sort;

	}

	public function set_input( $_option_name = 'option[]', $_option_value = '' ) {

		$_option_name  = is_string( $_option_name ) ? $_option_name : 'option[]';
		$_option_value = is_string( $_option_value ) ? $_option_value : '';

		$_string = '';

		$_string .= '<input type="text" name="' . $_option_name . '" value="' . esc_html( $_option_value ) . '" class="safse-admin-input-text" />';
		
		echo $_string;

	}

	public function set_textarea( $_option_name = 'option[]', $_option_value = '' ) {

		$_option_name  = is_string( $_option_name ) ? $_option_name : 'option[]';
		$_option_value = is_string( $_option_value ) ? $_option_value : '';

		$_string = '';

		$_string .= '<textarea name="' . $_option_name . '" class="saple-admin-textarea" />' . esc_html( $_option_value ) . '</textarea>';
		
		echo $_string;

	}

	public function set_select( $_select_array = false, $_option_name = 'option[]', $_option_value = '' ) {

		$_select_array = is_array( $_select_array ) ? $_select_array : array( 'select' => 'Select' );
		$_option_name  = is_string( $_option_name ) ? $_option_name : 'option[]';
		$_option_value = is_string( $_option_value ) ? $_option_value : '';

		$_string = '';

		$_string .= '<select name="' . $_option_name . '" class="safse-admin-select">';

		foreach ( $_select_array as $_key => $_val ) {
			$_string .= '<option value="' . esc_html( $_key ) . '"' . ( $_key === $_option_value ? ' selected="selected"' : '' ) . '>';
			$_string .= esc_html( __( $_val, 'safse' ) );
			$_string .= '</option>';
		}

		$_string .= '</select>';
		
		echo $_string;

	}

	public function set_checkbox( $_select_array = false, $_option_name = 'option[]', $_option_value = false) {

		$_select_array = is_array( $_select_array ) ? $_select_array : array( 0 => 'check' );
		$_option_name  = is_string( $_option_name ) ? $_option_name : 'option[]';
		$_option_value = is_array( $_option_value ) ? $_option_value : array( 0 => '' );

		$_string = '';

		foreach ( $_select_array as $_key => $_val ) {
			$_string .= '<label class="safse-admin-label">';
			$_string .= '<input type="checkbox" name="' . $_option_name . '[]' . '" value="' . esc_html( $_val ) . '"' . ( in_array( $_val, $_option_value ) ? ' checked="checked"' : '' ) . ' class="safse-admin-checkbox" />';
			$_string .= esc_html( __( $_val, 'safse' ) );
			$_string .= '</label>';
		}
		
		echo $_string;

	}

}

class SafseFrontal {

	public static $_safse_sort_select_count = 0;

	private $_safse_keywords = '';

	function __construct() {

		add_action( 'template_redirect', array( $this, 'disable_404' ) );
		add_action( 'pre_get_posts', array( $this, 'query_rewrite' ) );

		add_filter( 'get_search_query', array( $this, 'search_query' ), 999, 1 ); 

	}

	public function query_rewrite( $_query ) {

		global $SafseAdmin;

		$_option = $SafseAdmin->option();

		if ( 'rewrite' === $_option['loop_mode'] && $_query->is_search && $this->is_mode() ) {

			$_is_search = $_query->is_search;
			$this->_safse_keywords = $_query->query_vars['s'];

			$_rewrite_query = $this->request_query( 'no' );
			$_query->parse_query( $_rewrite_query );

			if ( $_is_search ) {

				$_query->is_front_page = false;
				$_query->is_home = false;
				$_query->is_search = true;
				$_query->is_front_page = false;

			}

		}

	}

	public function search_query( $_get_query_var ) { 

		global $SafseAdmin;

		$_option = $SafseAdmin->option();

		if ( 'rewrite' === $_option['loop_mode'] && is_search() && $this->is_mode() ) {
			$_get_query_var = $this->_safse_keywords;
		}

		return $_get_query_var;

	}

	public function disable_404() {

		global $wp_query;
		global $SafseAdmin;

		$_option = $SafseAdmin->option();

		if( 'rewrite' !== $_option['loop_mode'] && is_404() && $this->is_mode() ) {

			status_header( 200 );

			$wp_query->is_404 = 0;
			$wp_query->is_search = 1;

		}

	}

	public function search_param() {

		$_param = array();
		$_data_type = array();

		if( isset( $_POST ) && count( $_POST ) > 0 )
			$_data_type = $_POST;

		elseif( isset( $_GET ) && count( $_GET ) > 0 )
			$_data_type = $_GET;

		$_param['mode']   = isset( $_data_type['mode'] ) && 'safse' === $_data_type['mode'] ? $_data_type['mode'] : '';
		$_param['sort']   = isset( $_data_type['sort'] ) && '' !== $_data_type['sort'] ? $_data_type['sort'] : '';
		$_param['pt']     = isset( $_data_type['pt'] ) && '' !== $_data_type['pt'] ? $_data_type['pt'] : '';
		$_param['fp']     = isset( $_data_type['fp'] ) && '' !== $_data_type['fp'] ? $_data_type['fp'] : '';
		$_param['tid']    = isset( $_data_type['tid'] ) && '' !== $_data_type['tid'] ? $_data_type['tid'] : '';
		$_param['btax']   = isset( $_data_type['btax'] ) && '' !== $_data_type['btax'] ? $_data_type['btax'] : '';
		$_param['bterm']  = isset( $_data_type['bterm'] ) && '' !== $_data_type['bterm'] ? $_data_type['bterm'] : '';
		$_param['kmeth']  = isset( $_data_type['kmeth'] ) && '' !== $_data_type['kmeth'] ? $_data_type['kmeth'] : '';

		return $_param;

	}

	public function is_mode() {

		$_param = $this->search_param();
		$_param = '' !== $_param['mode'] ? true : false;
		
		return $_param;

	}

	public function get_mode() {

		$_string = '';

		$_string .= '<input type="hidden" name="mode" value="safse" />';

		return $_string;

	}

	public function get_terms_checkbox( $_inc_term_checkbox = 'no' ) {

		global $SafseAdmin;

		$_string = '';

		$_option     = $SafseAdmin->option();
		$_param      = $this->search_param();
		$_taxonomies = array();

		$_option['post_type'] = $_option['post_type'] ? $_option['post_type'] : array( 'post', 'page' );

		if ( is_array( $_param['pt'] ) ) {
			$_option['post_type'] = $_param['pt'];
		}

		$_taxonomies = array_diff( get_object_taxonomies( $_option['post_type'] ), array( 'post_format' ) );

		$_string .= '<div class="safse-taxonomies-wrap">';

		foreach ( $_taxonomies as $_key => $_val ) {

			$_taxonomy = get_taxonomy( $_val );
			$_terms = get_terms( $_val );

			if( is_array( $_terms ) && 0 < count( $_terms ) ) {
				if( 'yes' !== $_option['hide_checkbox_heading'] )
					$_string .= '<h3 class="safse-taxonomy-title">' . $_taxonomy->label . '</h3>';

				$_string .= '<div class="safse-terms-wrap">';
			}

			foreach ( $_terms as $_term ) {
				$_string .= '<label class="safse-term-label">';
				$_string .= '<input type="checkbox" name="tid[]" value="' . $_term->term_id . '"';
				$_string .= ' ' . ( is_array( $_param['tid'] ) && false !== array_search( $_term->term_id, $_param['tid'] ) ? 'checked="checked"' :  '' );
				$_string .= 'class="safse-term-checkbox" />';
				$_string .= $_term->name;
				$_string .= '</label>';
			}

			if( is_array( $_terms ) && 0 < count( $_terms ) ) {
				$_string .= '</div>';
			}

		}

		$_string .= '</div>';

		if( 'yes' !== $_option['show_checkbox'] && 'yes' !== $_inc_term_checkbox )
			$_string = '';

		return $_string;

	}

	public function get_sort_select( $_script_append = 'append', $_inc_sort_select = 'no' ) {

		global $SafseAdmin;
		static $_safse_sort_select_count;

		$_safse_sort_select_count = $_safse_sort_select_count + 1;

		$_string = '';
		$_add_word = '';
		$_option = $SafseAdmin->option();

		$_option['sort_key']       = $_option['sort_key'] ? $_option['sort_key'] : array( 'post_date', 'post_title' );
		$_option['sort_key_names'] = $_option['sort_key_names'] ? $_option['sort_key_names'] : array( 'post_date' => __( 'Post Date', 'safse' ), 'post_title' => __( 'Post Title', 'safse' ) );
		$_option['sort_key_names']['post_date']  = '' !== $_option['sort_key_names']['post_date'] ? $_option['sort_key_names']['post_date'] : __( 'Post Date', 'safse' );
		$_option['sort_key_names']['post_title'] = '' !== $_option['sort_key_names']['post_title'] ? $_option['sort_key_names']['post_title'] : __( 'Post Title', 'safse' );

		$_param = $this->search_param();

		$_string .= '<div class="safse-sort-select-wrap"><select name="sort" id="safse-sort-select-' . $_safse_sort_select_count . '" class="safse-sort-select">';

		if( 'no' !== $_option['default_sort_char'] ) {
			$_string .= '<option value=""';
			if( isset( $_param['sort'] ) || '' === $_param['sort'])
				$_string .= ' ' . 'selected="selected"';
			$_string .= '>' . __( 'Sort', 'safse' ) . '</option>';
		}

		foreach ( $_option['sort_key'] as $_val ) {

			if( 'asc' !== $_option['set_sort_asc_or_desc'] ) {
				$_add_word = 'desc' !== $_option['set_sort_asc_or_desc'] && 'asc' !== $_option['set_sort_asc_or_desc'] ? __( ' - Descending', 'safse' ) : '';
				$_string .= '<option value="' . esc_html( $_val ) . ',desc"';
				if( isset( $_param['sort'] ) && esc_html( $_val ) . ',desc' === $_param['sort'] )
					$_string .= ' ' . 'selected="selected"';
				$_string .= '>' . esc_html( $_option['sort_key_names'][$_val] ) . $_add_word . '</option>';
			}

			if( 'desc' !== $_option['set_sort_asc_or_desc'] ) {
				$_add_word = 'desc' !== $_option['set_sort_asc_or_desc'] && 'asc' !== $_option['set_sort_asc_or_desc'] ? __( ' - Ascending', 'safse' ) : '';
				$_string .= '<option value="' . esc_html( $_val ) . ',asc"';
				if( isset( $_param['sort'] ) && esc_html( $_val ) . ',asc' === $_param['sort'])
					$_string .= ' ' . 'selected="selected"';
				$_string .= '>' . esc_html( $_option['sort_key_names'][$_val] ) . $_add_word . '</option>';
			}

		}

		$_string .= '</select></div>';

		if ( 'append' === $_script_append )	{

			$_string .= '<script type="text/javascript">';
			$_string .= '
			(function() {
				var safse_select = document.getElementById( \'safse-sort-select-' . $_safse_sort_select_count . '\' ),
					safse_param_array = location.search.substring(1).split( \'&\' );
				safse_select.addEventListener(\'change\', function() {
					var safse_url_string = location.protocol + \'//\' + location.host + location.pathname,
						safse_sort_none = false;
					for ( var i = 0; i <= safse_param_array.length - 1; i++ ) {
						if( safse_param_array[i] != \'\' ){
							safse_url_string += safse_url_string == location.protocol + \'//\' + location.host + location.pathname ? \'?\' : \'&\';
						}
						if( safse_param_array[i].indexOf(\'sort=\') > -1 ) {
							safse_param_array[i] = \'sort=\' + safse_select.value;
							safse_sort_none = true;
						}
						safse_url_string += safse_param_array[i];
					}
					if( ! safse_sort_none ) {
						safse_url_string += \'&sort=\' + safse_select.value;
					}
					location.href = safse_url_string;
				});
			})();
			';
			$_string .= '</script>';

		}

		if ( 'yes' !== $_option['search_form_show_sort'] && 'yes' !== $_inc_sort_select )
			$_string = '';

		return $_string;

	}

	public function get_sort_hidden( $_inc_sort_hidden = 'no' ) {

		global $SafseAdmin;

		$_string = '';
		$_option = $SafseAdmin->option();

		$_sort       = '';
		$_sort_key   = '';
		$_sort_order = '';

		$_param = $this->search_param();

		$_sort_key = $_option['sort_key'] ? $_option['sort_key'] : array( 'post_date', 'post_title' );
		$_sort_key = $_sort_key[0];

		if ( 'desc' === $_option['set_sort_asc_or_desc'] )
			$_sort_order = 'desc';
		elseif ( 'asc' === $_option['set_sort_asc_or_desc'] )
			$_sort_order = 'asc';
		else
			$_sort_order = 'desc';

		$_sort = $_sort_key . ',' . $_sort_order;

		if ( '' !== $_param['sort'] )
			$_sort = $_param['sort'];

		if( 'yes' !== $_option['pass_sort_hidden'] && 'yes' !== $_inc_sort_hidden )
			$_sort = $_sort_key . ',' . $_sort_order;

		$_string .= '<input type="hidden" name="sort" value="' . esc_html( $_sort ) . '" />';

		return $_string;

	}

	public function get_keyword_switch_user_radio( $_inc_keyword_switch_user_radio = 'no' ) {

		global $SafseAdmin;

		$_string = '';
		$_option = $SafseAdmin->option();

		$_param = $this->search_param();

		if ( 'yes' === $_option['keyword_switch_user'] ) {
			$_string .= '<div class="safse-keyword-switch-user-wrap">';
			$_string .= '<label class="safse-keyword-switch-user safse-keyword-switch-user-and"><input type="radio" name="kmeth" value="and" />' . __( 'AND', 'safse' ) . '</label>';
			$_string .= '<label class="safse-keyword-switch-user safse-keyword-switch-user-or"><input type="radio" name="kmeth" value="or" />' . __( 'OR', 'safse' ) . '</label>';
			$_string .= '</div>';

			if ( empty( $_param['kmeth'] ) )
				$_param['kmeth'] = 'and';

			if ( 'or' === $_param['kmeth'] ) {
				$_string = str_replace( 'value="or"', 'value="or" checked="checked"', $_string );
			} else {
				$_string = str_replace( 'value="and"', 'value="and" checked="checked"', $_string );
			}
		}

		if ( 'yes' !== $_option['keyword_switch_user'] && 'yes' !== $_inc_keyword_switch_user_radio )
			$_string = '';

		return $_string;

	}

	public function request_query( $_return_query = 'yes' ) {

		global $wpdb, $wp_query, $SafseAdmin;

		$_query = "";

		$_post_type        = "";
		$_fields_prefix    = "";
		$_fields_prefix_to_array = array();
		$_keyword_switch   = "";
		$_multibyte_space  = '';
		$_between_taxonomy = '';
		$_between_term     = array();

		$_exclude_title_post_types_to_array = array();
		$_exclude_content_post_types_to_array = array();

		$_keywords       = '';
		$_keywords_array = array();

		$_taxonomies = array();

		$_sort       = '';
		$_sort_key   = '';
		$_sort_array = '';
		$_order      = '';

		$_param = $this->search_param();

		$_option = $SafseAdmin->option();

		$_debug = array(
			'sql'   => '',
			'in'    => '',
			'term'  => '',
			'query' => '',
		);

		if ( false  === $_option['post_type'] ) {
			$_option['post_type'] = array( 'post', 'page' );
		}

		if( is_array( $_param['pt'] ) ){
			$_option['post_type'] = $_param['pt'];
		}

		foreach ( $_option['post_type'] as $_key => $_val ) {

			if ( $_post_type !== '' )
				$_post_type .= ' OR ';

			$_post_type .= "$wpdb->posts.post_type = '" . esc_html( $_val ) . "'";

		}

		if ( is_array( $_param['fp'] ) ){
			$_option['fields_prefix'] = $_param['fp'];
		}

		if ( '' !== $_option['fields_prefix'] ) {
			// Before ver 0.9.7
			//$_fields_prefix = " AND " . "$wpdb->postmeta.meta_key LIKE '" . esc_html( $_option['fields_prefix'] ) . "%'";
			// After ver 0.9.8 modify ver 0.9.7
			$_fields_prefix = esc_html( preg_replace( '/ |　|\t|(\r\n|\r|\n)/', '', $_option['fields_prefix'] ) );
			$_fields_prefix_to_array = explode( ',', $_fields_prefix );
			$_fields_prefix_to_array = array_values( array_filter( $_fields_prefix_to_array ) );
			$_fields_prefix = "";
			foreach ( $_fields_prefix_to_array as $_key => $_val ) {
				if ( '' !== $_val ) {
					$_fields_prefix .= "$wpdb->postmeta.meta_key LIKE '" . esc_html( $_val ) . "%'";
					if ( count( $_fields_prefix_to_array ) !== $_key + 1 ) {
						$_fields_prefix .= " OR ";
					}
				}
			}
			if ( ! empty( $_fields_prefix ) ) {
				$_fields_prefix = " AND (" . $_fields_prefix . ")";
			}
		}

		if ( 'or' === $_param['kmeth'] || 'and' === $_param['kmeth'] ) {
			if( 'or' === $_param['kmeth'] ) {
				$_keyword_switch = "OR";
			} else {
				$_keyword_switch = "AND";
			}
		} else {
			if ( 'or' === $_option['keyword_switch'] ) {
				$_keyword_switch = "OR";
			} else {
				$_keyword_switch = "AND";
			}
		}

		if ( 'separate' === $_option['multibyte_space'] ) {
			$_multibyte_space = ' |　';
		} else {
			$_multibyte_space = ' ';
		}

		if( ! empty( $_param['btax'] ) ){
			$_option['between_taxonomy'] = $_param['btax'];
		}

		if ( 'and' === $_option['between_taxonomy'] ) {
			$_between_taxonomy = 'and';
		} else {
			$_between_taxonomy = 'or';
		}

		if( is_array( $_param['bterm'] ) ){
			$_option['between_term'] = $_param['bterm'];
		}

		if( $_option['between_term'] ) {

			foreach ( $_option['between_term'] as $_key => $_val ) {
				if( isset( $_option['between_term'][$_key] ) ){
					if( 'notin' === $_option['between_term'][$_key] ) {
						$_between_term[$_key] = 'NOT IN';
					} elseif( 'and' === $_option['between_term'][$_key] ) {
						$_between_term[$_key] = 'AND';
					} else {
						$_between_term[$_key] = 'IN';
					}
				}
			}

		} else {
			$_between_term = array( 'category' => 'IN', 'post_tag' => 'IN' );
		}

		// After ver 0.9.8 addition
		if ( false !== $_option['exclude_title_post_types'] && is_array( $_option['exclude_title_post_types'] ) ) {
			$_exclude_title_post_types_to_array = $_option['exclude_title_post_types'];
			$_exclude_title_post_types_to_array = array_values( array_filter( $_exclude_title_post_types_to_array ) );
			foreach ( $_exclude_title_post_types_to_array as $_key => $_val ) {
				$_exclude_title_post_types_to_array[$_key] = "'" . esc_html( $_val ) . "'";
			}
		}
		if ( false !== $_option['exclude_content_post_types'] && is_array( $_option['exclude_content_post_types'] ) ) {
			$_exclude_content_post_types_to_array = $_option['exclude_content_post_types'];
			$_exclude_content_post_types_to_array = array_values( array_filter( $_exclude_content_post_types_to_array ) );
			foreach ( $_exclude_content_post_types_to_array as $_key => $_val ) {
				$_exclude_content_post_types_to_array[$_key] = "'" . esc_html( $_val ) . "'";
			}
		}

		if ( '' !== get_query_var( 's' ) ){

			$_keywords_array = preg_split( '/' . $_multibyte_space . '/', urldecode( get_query_var( 's' ) ) );

			foreach ( $_keywords_array as $_key => $_val ) {
				if ( '' !== $_val ){
					if ( '' !== $_keywords )
						$_keywords .= ' ' . $_keyword_switch . ' ';

					// Before ver 0.9.7
					//$_keywords .= '(';
					//$_keywords .= "$wpdb->posts.post_title LIKE '%" . esc_html( $_val ) . "%'";
					//$_keywords .= ' OR ';
					//$_keywords .= "$wpdb->posts.post_content LIKE '%" . esc_html( $_val ) . "%'";
					//$_keywords .= ' OR (';
					//$_keywords .= "$wpdb->postmeta.meta_value LIKE '%" . esc_html( $_val ) . "%'";
					//$_keywords .= "$_fields_prefix";
					//$_keywords .= ')';
					//$_keywords .= ')';

					// After ver 0.9.8 modify ver 0.9.7
					$_keywords .= '(';
					if ( 0 < count( $_exclude_title_post_types_to_array ) ) {
						$_keywords .= '(';
						$_keywords .= "$wpdb->posts.post_type NOT IN (" . implode( ',', $_exclude_title_post_types_to_array ) . ")";
						$_keywords .= ' AND ';
						$_keywords .= "$wpdb->posts.post_title LIKE '%" . esc_html( $_val ) . "%'";
						$_keywords .= ')';
					} else {
						$_keywords .= "$wpdb->posts.post_title LIKE '%" . esc_html( $_val ) . "%'";
					}
					$_keywords .= ' OR ';
					if ( 0 < count( $_exclude_content_post_types_to_array ) ) {
						$_keywords .= '(';
						$_keywords .= "$wpdb->posts.post_type NOT IN (" . implode( ',', $_exclude_content_post_types_to_array ) . ")";
						$_keywords .= ' AND ';
						$_keywords .= "$wpdb->posts.post_content LIKE '%" . esc_html( $_val ) . "%'";
						$_keywords .= ')';
					} else {
						$_keywords .= "$wpdb->posts.post_content LIKE '%" . esc_html( $_val ) . "%'";
					}
					$_keywords .= ' OR (';
					$_keywords .= "$wpdb->postmeta.meta_value LIKE '%" . esc_html( $_val ) . "%'";
					$_keywords .= "$_fields_prefix";
					$_keywords .= ')';
					$_keywords .= ')';

				}
			}

			$_keywords = 'AND (' . $_keywords . ')';

			if ( 'AND ()' === $_keywords )
				$_keywords = '';

		}

		// Before ver 0.9.7 bug
		//$_query = "
		//SELECT
		//	DISTINCT $wpdb->posts.ID
		//FROM
		//	$wpdb->posts
		//LEFT OUTER JOIN
		//	$wpdb->postmeta
		//ON
		//	$wpdb->posts.ID = $wpdb->postmeta.post_id
		//WHERE
		//	($_post_type)
		//	$_fields_prefix [ <- necessary ? ]
		//	$_keywords
		//	AND $wpdb->posts.post_status = 'publish'
		//";

		// After ver 0.9.8 modify ver 0.9.7 bug
		$_query = "
		SELECT
			DISTINCT $wpdb->posts.ID
		FROM
			$wpdb->posts
		LEFT OUTER JOIN
			$wpdb->postmeta
		ON
			$wpdb->posts.ID = $wpdb->postmeta.post_id
		WHERE
			($_post_type)
			$_keywords
			AND $wpdb->posts.post_status = 'publish'
		";

		if ( isset( $_param['sort'] ) ) {

			$_sort_array = explode( ',', $_param['sort'] );
			$_sort       = is_array( $_sort_array ) && isset( $_sort_array[0] ) ? $_sort_array[0] : '';
			$_sort_key   = $_sort;
			$_order      = is_array( $_sort_array ) && isset( $_sort_array[1] ) ? $_sort_array[1] : '';

		}

		if ( '' !== $_order ) {

			if('desc' === $_order )
				$_order = 'DESC';
			else
				$_order = 'ASC';

		}

		if ( '' !== $_sort ) {

			if ( 'post_title' === $_sort  ) {
				$_sort = "$wpdb->posts.post_title";
				$_sort_key = '';
			} elseif ( 'post_date' === $_sort ) {
				$_sort = "$wpdb->posts.post_date";
				$_sort_key = '';
			} else {
				$_sort = "$wpdb->postmeta.meta_value";
			}

		}

		if( '' !== $_sort && '' !== $_order ) {

			if( '' !== $_sort_key ) {
				$_query = "
				SELECT
					*
				FROM
					(
						$_query
							AND $wpdb->postmeta.meta_key = '$_sort_key'
						ORDER BY
							$_sort $_order
					) AS Query
				UNION
					$_query
					AND $wpdb->postmeta.meta_key <> '$_sort_key'
				";
			} else {
				$_query = "
					$_query
					ORDER BY
						$_sort $_order
				";
			}

		}/* else {

			$_query = "
				$_query
				ORDER BY
					$wpdb->posts.post_date DESC
			";

		}*/

		$_debug['sql'] = $_query;

		$_query = $wpdb->get_col( $_query );

		$_debug['in'] = $_query;

		if( is_array( $_param['tid'] ) ){

			$_taxonomies_array = array_diff( get_object_taxonomies( $_option['post_type'] ), array( 'post_format' ) );

			foreach ( $_taxonomies_array as $_key => $_val ) {
				$_terms = get_terms( $_val );
				$_terms_array = array();

				foreach ( $_terms as $_term ) {
					if ( false !== array_search( $_term->term_id, $_param['tid'] ) ) {
						array_push( $_terms_array, $_term->term_id );
					}
				}

				if( count( $_terms_array ) > 0 ) {
					$_taxonomies[$_key]['taxonomy'] = $_val;
					$_taxonomies[$_key]['field']    = 'term_id';
					$_taxonomies[$_key]['terms']    = $_terms_array;
					$_taxonomies[$_key]['operator'] = $_between_term[$_val];
				}
			}

			$_taxonomies = array_merge( $_taxonomies, array( 'relation' => $_between_taxonomy ) );

		}

		$_debug['term'] = $_taxonomies;

		if ( 'yes' !== $_return_query ) {

			$_query = array(
				'post_type' => $SafseAdmin->get_post_type(),
				'post__in'  => count($_query) > 0 ? $_query : array(0),
				'orderby'   => 'post__in',
				'tax_query' => $_taxonomies,
				'paged'     => intval( get_query_var( 'paged' ) ),
			);

		} else {

			$_query = new WP_Query( array(
				'post_type' => $SafseAdmin->get_post_type(),
				'post__in'  => count($_query) > 0 ? $_query : array(0),
				'orderby'   => 'post__in',
				'tax_query' => $_taxonomies,
				'paged'     => intval( get_query_var( 'paged' ) ),
			) );

			$wp_query->max_num_pages = $_query->max_num_pages;
		
		}

		$_debug['query'] = $_query;

		/*
		echo '<p>Simplicity Add Fields Search Engine - Enable.</p>';
		echo '<pre style="height:500px;">';
		var_dump( $_debug );
		echo '</pre>';
		*/

		return $_query;

	}

}
