<?php
/**
 * @package Simplicity Add Fields Search Engine
 * 
 * Copyright (C) 2018 CattleMute.
 *
 * Function
 *
 */

class SafseTool{

	function __construct() {

		add_action( 'init', array( $this, 'shortcode' ) );
		add_action( 'widgets_init', array( $this, 'register' ) );

	}

	public function register() {

		register_widget( 'SafseWidget' );

	}

	public function shortcode() {
		
		$safse_shortcode = new SafseShortcode();

		add_shortcode( 'safse_search', array( $safse_shortcode, 'shortcode' ) );

	}

}

class SafseWidget extends WP_widget{

	function __construct() {

		parent::__construct( 'safse_search', __( 'Search - Simplicity Add Fields Search Engine', 'safse' ), array( 'description' => __( 'Search in site of Simplicity Add Fields Search Engine', 'safse' ) ) );

	}

	public function form( $_instance ) {

		$_settings = array(
			'title' => array(
				'value' => isset( $_instance['title'] ) ? $_instance['title'] : '',
				'name'  => $this->get_field_name( 'title' ),
				'id'    => $this->get_field_id( 'title' ),
			),
			'templatefile' => array(
				'value' => isset( $_instance['templatefile'] ) ? $_instance['templatefile'] : '',
				'name'  => $this->get_field_name( 'templatefile' ),
				'id'    => $this->get_field_id( 'templatefile' ),
			),
		);

		require( dirname(__FILE__) . '/../views/template-widget.php' );

	}

	public function widget( $_args, $_instance ) {

		$_settings = array(
			'title'        => isset( $_instance['title'] ) ? $_instance['title'] : '',
			'templatefile' => isset( $_instance['templatefile'] ) ? $_instance['templatefile'] : '',
		);

		echo $_args['before_widget'];

		if( '' !== $_settings['title'] )
			echo $_args['before_title'] . $_settings['title'] . $_args['after_title'];

		if ( '' !== $_settings['templatefile'] && file_exists( get_stylesheet_directory() . '/' . $_settings['templatefile'] ) ) {

			require( get_stylesheet_directory() . '/' . $_settings['templatefile'] );

		} elseif ( file_exists( get_stylesheet_directory() . '/searchform-safse.php' ) ) {

			require( get_stylesheet_directory() . '/searchform-safse.php' );

		} else {

			global $SafseAdmin;
			$_option = $SafseAdmin->option();

			$_placeholder = '' !== $_option['placeholder_string'] ? $_option['placeholder_string'] : __( 'Search' );
			$_button      = '' !== $_option['button_string'] ? $_option['button_string'] : __( 'Search' );

			require( dirname( __FILE__ ) . '/../views/searchform-safse-default.php' );

		}

		echo $_args['after_widget'];

	}

}

class SafseShortcode {

	public function shortcode( $_atts ) {

		$_atts = shortcode_atts(
			array(
				'templatefile' => '',
			),
			$_atts, 'safse_search'
		);

		$_settings = array(
			'templatefile' => isset( $_atts['templatefile'] ) ? $_atts['templatefile'] : '',
		);

		if ( '' !== $_settings['templatefile'] && file_exists( get_stylesheet_directory() . '/' . $_settings['templatefile'] ) ) {

			require( get_stylesheet_directory() . '/' . $_settings['templatefile'] );

		} elseif ( file_exists( get_stylesheet_directory() . '/searchform-safse.php' ) ) {

			require( get_stylesheet_directory() . '/searchform-safse.php' );

		} else {

			global $SafseAdmin;
			$_option = $SafseAdmin->option();

			$_placeholder = '' !== $_option['placeholder_string'] ? $_option['placeholder_string'] : __( 'Search' );
			$_button      = '' !== $_option['button_string'] ? $_option['button_string'] : __( 'Search' );

			require( dirname( __FILE__ ) . '/../views/searchform-safse-default.php' );

		}


	}

}
