<?php
/**
 * @package Simplicity Add Fields Search Engine
 * 
 * Copyright (C) 2018 CattleMute.
 *
 * View - Template Setting
 *
 */
 ?>

<div class="wrap wrap-safse">
	<h1><?php _e( 'Search in site settings', 'safse' ); ?></h1>
	<form method="post" action="admin.php?page=safse_settings" class="form-safse">
		<table class="form-table form-safse-table">
			<tr>
				<th><?php _e( 'Export the plugins searchform template to theme', 'safse' ); ?></th>
				<td><?php $SafseAdmin->set_select( $_export_template_array, $_option_name . '[export_template]', $_option['export_template'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Loop mode', 'safse' ); ?></th>
				<td><?php $SafseAdmin->set_select( $_loop_mode_array, $_option_name . '[loop_mode]', $_option['loop_mode'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Post type', 'safse' ); ?></th>
				<td><?php $SafseAdmin->set_checkbox( $_post_type_array, $_option_name . '[post_type]', $_option['post_type'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Custom fields prefix to search', 'safse' ); ?></th>
				<td><?php $SafseAdmin->set_input( $_option_name . '[fields_prefix]', $_option['fields_prefix'] ); ?><p><?php _e( '* Multiple prefix can specified separated by commas.', 'safse' ); ?></p></td>
			</tr>
			<tr>
				<th><?php _e( 'Keywords search method', 'safse' ); ?></th>
				<td><?php $SafseAdmin->set_select( $_keyword_switch_array, $_option_name . '[keyword_switch]', $_option['keyword_switch'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Leave the keyword search method to user', 'safse' ); ?></th>
				<td><?php $SafseAdmin->set_select( $_keyword_switch_user_array, $_option_name . '[keyword_switch_user]', $_option['keyword_switch_user'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Multibyte space treatment', 'safse' ); ?></th>
				<td><?php $SafseAdmin->set_select( $_multibyte_space_array, $_option_name . '[multibyte_space]', $_option['multibyte_space'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Passing sort paramator', 'safse' ); ?></th>
				<td><?php $SafseAdmin->set_select( $_hide_checkbox_heading_array, $_option_name . '[pass_sort_hidden]', $_option['pass_sort_hidden'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Show default &quot;Sort&quot; on sort selectbox', 'safse' ); ?></th>
				<td><?php $SafseAdmin->set_select( $_default_sort_char_array, $_option_name . '[default_sort_char]', $_option['default_sort_char'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Show descending and ascending on sort selectbox', 'safse' ); ?></th>
				<td><?php $SafseAdmin->set_select( $_set_sort_asc_or_desc_array, $_option_name . '[set_sort_asc_or_desc]', $_option['set_sort_asc_or_desc'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Search form addition sort selectbox', 'safse' ); ?></th>
				<td><?php $SafseAdmin->set_select( $_search_form_show_sort_array, $_option_name . '[search_form_show_sort]', $_option['search_form_show_sort'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Placeholder string', 'safse' ); ?></th>
				<td><?php $SafseAdmin->set_input( $_option_name . '[placeholder_string]', $_option['placeholder_string'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Button string', 'safse' ); ?></th>
				<td><?php $SafseAdmin->set_input( $_option_name . '[button_string]', $_option['button_string'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Taxonomies checkbox show', 'safse' ); ?></th>
				<td><?php $SafseAdmin->set_select( $_show_checkbox_array, $_option_name . '[show_checkbox]', $_option['show_checkbox'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Taxonomies heading hide', 'safse' ); ?></th>
				<td><?php $SafseAdmin->set_select( $_hide_checkbox_heading_array, $_option_name . '[hide_checkbox_heading]', $_option['hide_checkbox_heading'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Logical between taxonomy', 'safse' ); ?></th>
				<td><?php $SafseAdmin->set_select( $_between_taxonomy_array, $_option_name . '[between_taxonomy]', $_option['between_taxonomy'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Logical between term', 'safse' ); ?></th>
				<td>
				<?php foreach ( $_between_term_include_array as $_taxonomy_name => $_taxonomy_between ): ?>
					<div class="text"><span class="caption"><?php _e( $_taxonomy_name, 'safse' ); ?></span><?php $SafseAdmin->set_select( $_between_term_array, $_option_name . '[between_term][' . $_taxonomy_name . ']', $_option['between_term'][$_taxonomy_name] ); ?></div>
				<?php endforeach; ?>
				</td>
			</tr>
			<tr>
				<th><?php _e( 'Sort key in selectbox', 'safse' ); ?></th>
				<td><?php $SafseAdmin->set_checkbox( $_sort_key_array, $_option_name . '[sort_key]', $_option['sort_key'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Sort key name', 'safse' ); ?></th>
				<td>
				<?php foreach ( $_sort_key_names_array as $_sort_key_name ): ?>
					<div class="text"><span class="caption"><?php echo esc_html( $_sort_key_name ); ?></span><?php $SafseAdmin->set_input(  $_option_name . '[sort_key_names][' . $_sort_key_name . ']', $_option['sort_key_names'][$_sort_key_name] ); ?></div>
				<?php endforeach; ?>
				</td>
			</tr>
			<?php // After ver 0.9.8 addition ?>
			<tr>
				<th><?php _e( 'Post types that excludes post title from search', 'safse' ); ?></th>
				<td><?php $SafseAdmin->set_checkbox( $_exclude_title_post_types_array, $_option_name . '[exclude_title_post_types]', $_option['exclude_title_post_types'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Post types that excludes post content from search', 'safse' ); ?></th>
				<td><?php $SafseAdmin->set_checkbox( $_exclude_content_post_types_array, $_option_name . '[exclude_content_post_types]', $_option['exclude_content_post_types'] ); ?></td>
			</tr>
		</table>
		<p class="submit"><button class="button-primary"><?php esc_attr_e( 'Save' ); ?></button></p>
	</form>

	<small class="copyright"><?php _e( 'Create by CattleMute.' ) ?><small>
</div>
